////////////////////////////////////////////////////////////////////////////////
// 
// IntegerVector.hh 
//
//    produced: 21/05/04 cw
// last change: 21/05/04 cw
//
// This program is free software; Please read COPYING
//  (GNU General Public Licence) for details
//
////////////////////////////////////////////////////////////////////////////////
#ifndef INTEGERVECTOR_HH
#define INTEGERVECTOR_HH

#include <assert.h>
#include <cmath>

#include "Array.hh"

#include "CommandlineOptions.hh"

typedef Array<parameter_type> integervector_data;

class IntegerVector : public integervector_data {
public:
  // constructors:
  inline IntegerVector();
  inline IntegerVector(const IntegerVector&);
  inline IntegerVector(const parameter_type&);
  inline IntegerVector(const size_type, const parameter_type&);
  // destructor:
  inline ~IntegerVector();
  // accessors:
  bool is_zero() const;
};

// constructors:
inline IntegerVector::IntegerVector() : 
  integervector_data() {
}
inline IntegerVector::IntegerVector(const IntegerVector& integervector) : 
  integervector_data(integervector) {
}
inline IntegerVector::IntegerVector(const parameter_type& init_entry) : 
  integervector_data(1, init_entry) {
}
inline IntegerVector::IntegerVector(const size_type init_size, const parameter_type& init_entry) :
  integervector_data(init_size, init_entry) {
}

// destructor:
inline IntegerVector::~IntegerVector() {}

#endif

// eof IntegerVector.hh
