////////////////////////////////////////////////////////////////////////////////
// 
// RSinter.hh 
//
//    produced: 2004/10/14 cw
//
// This program is free software; Please read COPYING
//  (GNU General Public Licence) for details
//
////////////////////////////////////////////////////////////////////////////////
#ifndef RSINTER_HH
#define RSINTER_HH

#include "setoper.h"
#include "Rational.h"

#include "cdd.h"
#include "LPinter.hh"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <string.h>

#include "Matrix.hh"

class RSinter {
private:
  dd_ErrorType     _err;
  dd_rowrange      _m;
  dd_colrange      _n;
  dd_MatrixPtr     _matrixptr;
  dd_Arow          _vo;
  dd_Arow          _rs;
private:
  RSinter();
public:
  // constructors:
  RSinter(const Matrix&, const Vector&, const Vector&);
  // destructor:
  inline ~RSinter();
  // functions:
  int shoot();
};

inline RSinter::~RSinter() {
  
  // Free allocated spaces:
  dd_FreeMatrix    (_matrixptr);
  dd_FreeArow      (_n,_vo);
  dd_FreeArow      (_n,_rs);
}

#endif

// eof RSinter.hh
