////////////////////////////////////////////////////////////////////////////////
// 
// VPolytope.hh 
//
//    produced: 21/05/04 cw
// last change: 21/05/04 cw
//
////////////////////////////////////////////////////////////////////////////////
#ifndef VPOLYTOPE_HH
#define VPOLYTOPE_HH

#include <assert.h>

#include "setoper.h"
#include "Rational.h"

#include "cdd.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include "Vector.hh"
#include "Matrix.hh"
#include "Adjacency.hh"

#include "CommandlineOptions.hh"

// (*this)[col][row], points are in rows

  Vector maximizer(const IntegerVector current);
class VPolytope : public Matrix {
private:
  Adjacency _adj;

public:
  // constructors:
  inline VPolytope();
  inline VPolytope(const VPolytope&);
  inline VPolytope(const Matrix&);
  // accessors:
  inline const parameter_type faj(const parameter_type& vtx_no,const parameter_type& ngbr_no) {
    assert(vtx_no>=0);
    assert(ngbr_no>=0);
    return _adj.get(vtx_no, ngbr_no);
  }
  Vector fej(const parameter_type&,const parameter_type&);
  Vector fej0(const parameter_type&,const parameter_type&);
  const size_type ngbrCount(const parameter_type& vtx_no);
  inline const parameter_type no()   const { return coldim(); }
  inline const parameter_type rank() const { return rowdim(); }
  // indexing:
  inline       Vector& operator()(const size_type);
  inline const Vector& operator()(const size_type) const;
  // adjacency
  void computeAdjacency();
  std::istream& readAdjacency(std::istream& ist);
  void writeAdjacency(std::ostream& ost);
  void removeRedundancy();
};

inline VPolytope::VPolytope() : 
  Matrix() {
}
inline VPolytope::VPolytope(const VPolytope& vpoly) : 
  Matrix(vpoly) {
}
inline VPolytope::VPolytope(const Matrix& matrix) : 
  Matrix(matrix) {
}

inline Vector& VPolytope::operator()(const size_type row) {
  return (*this)[row-1];
}

inline const Vector& VPolytope::operator()(const size_type row) const {
  return (*this)[row-1];
}

#endif

// eof VPolytope.hh
