#include <assert.h>
#include "CommandlineOptions.hh"
#include "Array.hh"
#include "VPolytopeList.hh"

int main(const int argc, const char** argv) {
  CommandlineOptions::init(argc, argv);

  dd_set_global_constants();  /* First, this must be called. */

  // Read the polytopes
  VPolytopeList polylist;

  if (!polylist.read(std::cin)) {
    std::cerr << "error while reading polytopes"<< std::endl;
    return 1;
  }

  if (!CommandlineOptions::mute()) {
    std::cerr << "Starting..." << std::endl;
  }
  VPolytope result = polylist.removeRedundancy();

  std::cout << result << std::endl;

  if (!CommandlineOptions::mute()) {
    std::cerr << std::endl;
  }

  return 0;
}
