#!/usr/bin/perl
# variable sort
# minkSum grouped
# no comment
$varnb = 0;
$parlevel = 0;
$vertex[$parlevel] = 0;
$temp = "temp.in";
$verbose = 0;

&clean;

while (<>) {
    chomp;
    $line = $_;
    if ($line =~ /^variable/i) {
	while ($line =~ / ([a-zA-Z][a-zA-Z0-9]*)/cg) {
	    if (!$var{$1}) {
		$varlist[$varnb] = $1;
		$varnb++;
		$var{$1} = $varnb;
	    }	    
	}
	next;
    }

    while ($line =~ /([^+\-()]*)([+-]?)(\(|\))?(\^([0-9]+))?/cg) {
	$point =$1;
	$oper = $2;
	$par = $3;
	$pow = $5;
	if ($par eq '(' && !($oper eq "+" || $oper eq "-") &&
	    $opisplus[$parlevel] != 2) {
	    $parlevel++;
	    $opisplus[$parlevel] = 2;
	    $vertex[$parlevel]=0;
	    &clean;
	    $vertex[$parlevel]++;
	}
	while ($point =~ /([a-zA-Z][a-zA-Z0-9]*)\^?([0-9]+)?/cg) {
	    if (!$var{$1}) {
		$varlist[$varnb] = $1;
		$varnb++;
		$var{$1} = $varnb;
	    }
	    if ($opisplus[$parlevel] == 2) {
		for ($i=0; $i<$vertex[$parlevel]; $i++) {
		    if ($2) {
			$values[$parlevel][$i][$var{$1}]+=$2;
		    } else {
			$values[$parlevel][$i][$var{$1}]++;
		    }
		}
	    } else {
		if ($2) {
		    $values[$parlevel][$vertex[$parlevel]][$var{$1}]+=$2;
		} else {
		    $values[$parlevel][$vertex[$parlevel]][$var{$1}]++;
		}
		    $values[$parlevel][$vertex[$parlevel]][$var{$1}]."\n";
	    }
	}
	if ($point =~ /[a-zA-Z0-9]/ && $opisplus[$parlevel] != 2) {
	    $vertex[$parlevel]++;
	}
	&clean;
	if ($par eq ')') {
	    if ($opisplus[$parlevel] == 2) {
		$powbackup = $pow;
		$pow = 1;
		&uplevel;
		$pow = $powbackup;
	    }
	    &uplevel;
	}
	if (($oper eq "+" || $oper eq "-") && $opisplus[$parlevel] == 2 ) {
	    &uplevel;
	}
	if ($par eq '(') {
	    if ($oper eq '+' || $oper eq '-') {
		$parlevel++;
		$opisplus[$parlevel] = 2;
		$vertex[$parlevel]=0;
		&clean;
		$parlevel++;
		$opisplus[$parlevel] = 1;
	    } else  {
		$parlevel++;
		$opisplus[$parlevel] = 0;
	    }
	    $vertex[$parlevel]=0;
	    &clean;
	} elsif ($oper eq '+' || $oper eq '-') {
	}
	# &printall;
    }
}

if ($opisplus[$parlevel] == 2) {
    &uplevel;
}

if ($verbose) {
    print STDERR "Convex hull of";
}
open TEMP, ">$temp" or die "can't open $temp\n";
print TEMP "[\n";
&output;
print TEMP "]\n";
close TEMP;
$out = `./convexHull -m < $temp`;
if ($verbose) {
    print STDERR "Variable order is \n";
    for ($j=0;$j<$varnb; $j++) {
	print STDERR " ".$varlist[$j];
    }
    print STDERR "\n";
}

print $out;


sub uplevel {
    # CONVEX($parlevel);
    if ($verbose) {
	print STDERR "Convex hull of";
    }

    open TEMP, ">$temp" or die "can't open $temp\n";
    print TEMP "[\n";
    &output;
    print TEMP "]\n";
    close TEMP;
    $out = `./convexHull -m < $temp`;

    $vertex[$parlevel] = 0;
    &read;
    if ($pow && $pow > 1) {
	# MULTIPLY($parlevel);
	for ($i=0;$i<$vertex[$parlevel];$i++) {
	    for ($j=1;$j<=$varnb;$j++) {
		$values[$parlevel][$i][$j] *= $pow;

	    }
	}
    }
    if ($opisplus[$parlevel]) {
	# APPEND($parlevel,$parlevel-1);
	if ($opisplus[$parlevel] == 2 && $toSum[$parlevel]>0) {
	    # SUM($parlevel,$parlevel-$toSum[$parlevel])
	    if ($verbose) {
		print STDERR "Minkowski sum of ".(1+$toSum[$parlevel])." polytopes with respectively:\n"
	    }
	    open TEMP, ">$temp" or die "can't open $temp\n";
	    print TEMP "[\n";
	    &output;
	    while ($toSum[$parlevel]>0) {
		$toSum[$parlevel] = 0;
		$parlevel--;
		&output;
	    }
	    print TEMP "]\n";
	    close TEMP;
	    if ($verbose) {
		print STDERR "\n";
	    }
	    # print `more $temp`;
	    $out = `./minkSum -s -m < $temp`;
	    $vertex[$parlevel] = 0;
	    &read;
	}
	$parlevel--;
	for ($i=0;$i<$vertex[$parlevel+1];$i++) {
	    for ($j=1;$j<=$varnb;$j++) {
		$values[$parlevel][$vertex[$parlevel]][$j] =
		    $values[$parlevel+1][$i][$j];
	    }
	    $vertex[$parlevel]++;
	}
    } else {
	if ($opisplus[$parlevel-1] == 2) {
	    $toSum[$parlevel] = 1+$toSum[$parlevel-1];
	    $opisplus[$parlevel] = 2;
	} else {
	    # SUM($parlevel,$parlevel-1);
	    open TEMP, ">$temp" or die "can't open $temp\n";
	    print TEMP "[\n";
	    &output;
	    $parlevel--;
	    &output;
	    print TEMP "]\n";
	    close TEMP;
	    $out = `./minkSum -s -m< $temp`;
	    $vertex[$parlevel] = 0;
	    &read;
	}
    }

}

sub output {
    if ($verbose) {
	print STDERR " ".$vertex[$parlevel]." vertices\n";
    }
    print TEMP "[\n";
    for ($i=0;$i<$vertex[$parlevel]; $i++) {
	print TEMP "[";
	for ($j=1;$j<$varnb; $j++) {
	    if ($values[$parlevel][$i][$j]) {
		print TEMP $values[$parlevel][$i][$j];
	    } else {
		print TEMP 0;
	    }
	    print TEMP ",";
	}
	if ($values[$parlevel][$i][$varnb]) {
	    print TEMP $values[$parlevel][$i][$varnb];
	} else {
	    print TEMP 0;
	}
	print TEMP "]";
	if ($i < $vertex[$parlevel]-1) {
	    print TEMP ",";
	}
	print TEMP "\n";
    }
    print TEMP "]\n";
}

sub read {
    $i=1;
    while ($out =~ /([0-9]+)(\]?),?/cg) {
	$values[$parlevel][$vertex[$parlevel]][$i++] = $1;
	if ($2 eq "]") {
	    $vertex[$parlevel]++;
	    $i=1;
	}
    }
}

sub clean {
    for ($i=1;$i<=$varnb; $i++) {
	$values[$parlevel][$vertex[$parlevel]][$i]=0;
    }
}

sub printall {
    $parlevelbackup = $parlevel;
    print "PRINTALL\n";

    for ($parlevel = 0; $parlevel <= $parlevelbackup; $parlevel++) {

	print "out $parlevel (".$vertex[$parlevel]."), op = ".
	    $opisplus[$parlevel].", to = ".$toSum[$parlevel]."\n";
	print "[\n";
	for ($i=0;$i<$vertex[$parlevel]; $i++) {
	    print "[";
	    for ($j=1;$j<$varnb; $j++) {
		if ($values[$parlevel][$i][$j]) {
		    print $values[$parlevel][$i][$j];
		} else {
		    print 0;
		}
		print ",";
	    }
	    if ($values[$parlevel][$i][$varnb]) {
		print $values[$parlevel][$i][$varnb];
	    } else {
		print 0;
	    }
	    print "]";
	    if ($i < $vertex[$parlevel]-1) {
		print ",";
	    }
	    print "\n";
	}
	print "]\n";

    }
    $parlevel = $parlevelbackup;
}
