#!/usr/bin/perl

# cdd format -> poly format
# SYNTAX :
# perl cdd2polyInput file1.ext file2.ext ... fileN.ext > data.in
# It is also possile to read from standard input,
# allowing such things as:
# cat file1.ext file2.ext ... fileN.ext | ./cdd2polyInput.pl

if ($ARGV[0] =~ /^-+h/) {
    print stderr "Syntax : perl cdd2polyInput.pl file1.ext file2.ext ... fileN.ext > data.in \n";
    die "You can also read the data from standard input\n";
}

print "[";
$num = 0;
while (<>) {
    if (/^begin/) {
	if ($first_line != 0) {
	    die "One of the files is missing an end\n";
	}
	$first_line = 1;
	$num++;
	if ($not_first_file) {
	    print ",\n";
	}
	print "[";
	$not_first_file = 1;
    } elsif ($first_line == 1) {
	if (/([0-9]+) *([0-9]+) *([a-z]+)/) {
	    $first_line = 2;
	    $size = $1;
	    $rank = $2;
	    if ((lc ($3) ne "rational") && (lc ($3) ne "integer")) {
		die "Invalid format : $3 should be rational or integer\n";
	    }
	} else {
	    die "Invalid first line : >$_<\n";
	}
    } elsif ($first_line == 2) {
	if (/^end/) {
	    print "]";
	    $first_line = 0;
	    $second_line = 0;
	} else {
	    if ($second_line == 1) {
		print ",\n";
	    }
	    $second_line = 1;
	    print "[";
	    $c = 0;
	    chomp;
	    while (/([^ ]+)/cg) {
		$c++;
		if ($c==2) {
		    print "$1";
		}
		if ($c>2) {
		    print ",$1";
		}
	    }
	    print "]";
	}
    }
}
if ($first_line != 0) {
    die "Last file was missing an end\n";
}
print "]\n";
