#!/usr/bin/perl

# [decomp]:[coord]:[max] -> cdd format
# only uses middle of line ([coord])
# SYNTAX :
# perl polyOuput2cdd sum.out > sum.ext
# It is also possile to read from standard input,
# allowing things like:
# ./minkSum < data.in | perl polyOuput2cdd

if ($ARGV[0] =~ /^-+h/) {
    print stderr "Syntax : perl polyOuput2cdd sum.out > sum.ext\n";
    print stderr "You can also read the data from standard input :\n";
    print stderr "         perl polyOuput2cdd < sum.out > sum.ext\n";
    die          " or      ./minkSum < data.in | perl polyOuput2cdd\n";
}

print "V-representation\nbegin\n";

$first = 1;
$out = "";
$rank = 0;
$rankfound = 0;
$size = 0;
while (<>) {
    if (m%\: \[([^ ]*)\] \:%) {
	$out .= " 1";
	$line = $1;
	while ($line =~ /([^,]+)/cg) {
	    $rank++;
	    $out .= " $1";
	}
	$out .= "\n";
	$size++;
	if ($rankfound == 0) {
	    $rankfound = $rank;
	} elsif ($rankfound != $rank) {
	    die "$rankfound different from $rank at vertex $size\n";
	}
	$rank = 0;
    }
}
$rankfound++;

print " $size $rankfound rational\n";

print $out;
print "end\n";
