/*  PyMINKSUM: A Python wrapper to Christophe Weibels MINKSUM C++ library. 
    Copyright (C) 2010  Benjamin Kern <benjamin.kern@ovgu.de>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MINKSUM_H
#define _MINKSUM_H

#include "VPolytopeList.hh"
// #include <iostream>
// #include "CommandlineOptions.hh"
#include "CXX/Extensions.hxx"
#include "CXX/Objects.hxx"
#include "numpy/arrayobject.h"

// Helper functions
Matrix PyArrayToMatrix(PyArrayObject* x);
Py::Object MatrixToPyArray(const Matrix& M);

class Polytope : public Py::PythonExtension<Polytope> {
  public:
    static void init_type(void);
    Polytope(const Matrix& M);
    Polytope(const VPolytope& V);
    virtual ~Polytope();
    Py::Object generators(void);
    Py::Object convexhull(void);
    const VPolytope& get_vpolytope() const {
      return vpoly;
    };
    const size_t get_dim_vertices() const {
      return dim_vertices;
    };
  private:
    VPolytope vpoly;
    size_t dim_vertices;
};

class Convexsets : public Py::ExtensionModule<Convexsets> {
  public:
    Convexsets();
    Py::Object minksum(const Py::Tuple &args);
//     virtual ~Convexsets();
  private:
    Py::Object new_polytope(const Py::Tuple &args);
};

#endif
