#!/usr/bin/env python
from __future__ import division
import numpy as np
import setbasedmethods.convexsets as sbm
################################
# Octogon example
################################
p1 = np.array([[1,-1],
              [1, 1],
              [-1,1],
              [-1,-1]])
p2 = np.array([[0,-1],
              [-1,0],
              [0,1],
              [1,0]])
poly1 = sbm._convexsets.Polytope(p1)
poly2 = sbm._convexsets.Polytope(p2)
poly3 = sbm._convexsets.Minksum((poly1,poly2))
print "Octogon.out"
print poly3.generators()
################################
# samp1 example
################################
p1 = np.array([[1,-1,-1],
               [1,-1,1],
               [1,1,1],
               [1,1,-1],
               [-1,1,1],
               [-1,1,-1],
               [-1,-1,1],
               [-1,-1,-1]])
p2 = np.array([[0,-1,1],
               [-1,0,1],
               [0,1,1],
               [1,0,1],
               [1,1,0],
               [1,0,-1],
               [1,-1,0],
               [0,1,-1],
               [-1,1,0],
               [-1,0,-1],
               [0,-1,-1],
               [-1,-1,0]])
poly1 = sbm._convexsets.Polytope(p1)
poly2 = sbm._convexsets.Polytope(p2)
poly3 = sbm._convexsets.Minksum((poly1,poly2))
print "samp1.out"
print poly3.generators()
################################
# samp2 example
################################
p1 = np.array([[1,2,1],[1.6,1.6,1],[1.5,1.5,0.5],
               [0.4,8/5,1],[1,8/5,2/5],[8/5,1,2/5],
               [1/2,3/2,1/2],[1,1,0],[2/5,2/5,1],
               [1,2/5,2/5],[1/2,1/2,1/2],[2/5,1,2/5],
               [3/2,1/2,1/2],[1,0,1],[1/2,1/2,3/2],
               [0,1,1],[8/5,2/5,1],[1,2/5,8/5],
               [2/5,1,8/5],[3/2,1/2,3/2],[1/2,3/2,3/2],
               [2,1,1],[8/5,1,8/5],[1,1,2],[1,8/5,8/5],[3/2,3/2,3/2]])
p2 = np.array([[0,1,2],[0,2,1],[2,1,0],
               [1,2,0],[0,0,1],[1,0,0],
               [0,1,0],[1,0,2],[2,0,1],
               [2,1,2],[2,2,1],[1,2,2]])
poly1 = sbm._convexsets.Polytope(p1)
poly2 = sbm._convexsets.Polytope(p2)
poly3 = sbm._convexsets.Minksum((poly1,poly2))
print "samp2.out"
print poly3.generators()
################################
# samp3 example
################################
p1 = np.array([[10,20,10],[16,16,10],[15,15,5],[4,16,10],[10,16,4],
               [16,10,4],[5,15,5],[10,10,0],[4,4,10],[10,4,4],[5,5,5],
               [4,10,4],[15,5,5],[10,0,10],[5,5,15],[0,10,10],[16,4,10],
               [10,4,16],[4,10,16],[15,5,15],[5,15,15],[20,10,10],
               [16,10,16],[10,10,20],[10,16,16],[15,15,15]])
p2 = np.array([[0,10,20],[0,20,10],[20,10,0],[10,20,0],
               [0,0,10],[10,0,0],[0,10,0],[10,0,20],[20,0,10],
               [20,10,20],[20,20,10],[10,20,20]])
poly1 = sbm._convexsets.Polytope(p1)
poly2 = sbm._convexsets.Polytope(p2)
poly3 = sbm._convexsets.Minksum((poly1,poly2))
print "samp3.out"
print poly3.generators()
################################
# cubeAndCross example
################################
p1 = np.array([[0,0,0],[1,0,0],[0,1,0],[1,1,0],[0,0,1],[1,0,1],[0,1,1],[1,1,1]])
p2 = np.array([[-1,0,0],[1,0,0],[0,-1,0],[0,1,0],[0,0,-1],[0,0,1]])

poly1 = sbm._convexsets.Polytope(p1)
poly2 = sbm._convexsets.Polytope(p2)
poly3 = sbm._convexsets.Minksum((poly1,poly2))
print "cubeAndCross.out"
print poly3.generators()
################################
# hm1 example
################################
p1 = [np.array([[2,0,0,0,3,0,0,0],[1,1,0,0,2,0,1,0],[1,0,1,0,2,0,1,0],
               [0,1,1,0,2,0,1,0],[0,1,1,0,1,0,2,0],[0,1,0,1,1,0,2,0],
               [0,0,1,1,1,0,2,0],[0,0,0,2,0,0,3,0]])]
p1.append(np.array([[2,0,0,0,2,1,0,0],[1,0,1,0,1,1,1,0],[0,1,1,0,1,1,1,0],
               [0,0,1,1,0,1,2,0],[1,1,0,0,2,0,0,1],[0,1,1,0,1,0,1,1],
               [0,1,0,1,1,0,1,1],[0,0,0,2,0,0,2,1]]))
p1.append(np.array([[2,0,0,0,2,1,0,0],[1,1,0,0,1,1,1,0],[1,0,1,0,1,1,1,0],
               [0,1,1,0,0,1,2,0],[0,1,1,0,2,0,0,1],[0,1,0,1,1,0,1,1],
               [0,0,1,1,1,0,1,1],[0,0,0,2,0,0,2,1]]))
p1.append(np.array([[2,0,0,0,1,2,0,0],[1,0,1,0,0,2,1,0],[1,1,0,0,1,1,0,1],
               [0,1,1,0,1,1,0,1],[0,1,1,0,0,1,1,1],[0,0,1,1,0,1,1,1],
               [0,1,0,1,1,0,0,2],[0,0,0,2,0,0,1,2]]))
p1.append(np.array([[2,0,0,0,2,1,0,0],[1,1,0,0,1,1,1,0],[0,1,1,0,1,1,1,0],
               [0,1,0,1,0,1,2,0],[1,0,1,0,2,0,0,1],[0,1,1,0,1,0,1,1],
               [0,0,1,1,1,0,1,1],[0,0,0,2,0,0,2,1]]))
p1.append(np.array([[2,0,0,0,1,2,0,0],[0,1,1,0,0,2,1,0],[1,1,0,0,1,1,0,1],
               [1,0,1,0,1,1,0,1],[0,1,0,1,0,1,1,1],[0,0,1,1,0,1,1,1],
               [0,1,1,0,1,0,0,2],[0,0,0,2,0,0,1,2]]))
p1.append(np.array([[2,0,0,0,1,2,0,0],[1,1,0,0,0,2,1,0],[1,0,1,0,1,1,0,1],
               [0,1,1,0,1,1,0,1],[0,1,1,0,0,1,1,1],[0,1,0,1,0,1,1,1],
               [0,0,1,1,1,0,0,2],[0,0,0,2,0,0,1,2]]))
p1.append(np.array([[2,0,0,0,0,3,0,0],[1,1,0,0,0,2,0,1],[1,0,1,0,0,2,0,1],
               [0,1,1,0,0,2,0,1],[0,1,1,0,0,1,0,2],[0,1,0,1,0,1,0,2],
               [0,0,1,1,0,1,0,2],[0,0,0,2,0,0,0,3]]))
polylist = tuple([sbm._convexsets.Polytope(i) for i in p1])
poly2 = sbm._convexsets.Minksum(polylist)
print "hm1.out"
print poly2.generators()
################################
# cube15 example
################################
p1=[np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0]])]

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,1,0,0,0,0,0,0,0,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,0,1,0,0,0,0,0,0,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,0,0,1,0,0,0,0,0,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,0,0,0,1,0,0,0,0,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,0,0,0,0,1,0,0,0,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,0,0,0,0,0,1,0,0,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,0,0,0,0,0,0,1,0,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
               [0,0,0,0,0,0,0,0,1,0,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                [0,0,0,0,0,0,0,0,0,1,0,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                [0,0,0,0,0,0,0,0,0,0,1,0,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                [0,0,0,0,0,0,0,0,0,0,0,1,0,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                [0,0,0,0,0,0,0,0,0,0,0,0,1,0,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                [0,0,0,0,0,0,0,0,0,0,0,0,0,1,0]]))

p1.append(np.array([[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                [0,0,0,0,0,0,0,0,0,0,0,0,0,0,1]]))

polylist = tuple([sbm._convexsets.Polytope(i) for i in p1])

# poly2 = sbm._convexsets.Minksum(polylist)
# print "cupe15.out"
# print poly2.generators()
################################
# Random Convex Hull example
################################
temp = np.random.random((100,4))
c = np.vstack((temp,0.5*temp,0.1*temp))
poly1 = sbm._convexsets.Polytope(c)
print("Random Convex Hull Example")
print("Shape before")
print poly1.generators().shape
polynew = poly1.convexhull()
print("Shape afterwards")
print polynew.generators().shape
