#!/usr/bin/env python
from __future__ import division
import numpy as np
import setbasedmethods.convexsets as sbm

# Create some random arrays, which 
p1 = np.random.random((10,4))
p2 = np.random.random((10,4))
# Create polytope objects
poly1 = sbm._convexsets.Polytope(p1)
poly2 = sbm._convexsets.Polytope(p2)
# Check the vertices of the polytopes
print poly1.generators()
print poly2.generators()
# Take Minkowski sum Poly3 = Poly1 + Poly2
poly3 = sbm._convexsets.Minksum((poly1,poly2))
# Take Minkowski sum Poly4 = Poly1 + Poly2 + Poly2 + Poly1
poly4 = sbm._convexsets.Minksum((poly1,poly2,poly2,poly1))
# Get the vertices of the new polytopes
a = poly3.generators()
b = poly4.generators()
# Create a polytope, from vertices of a, 0.5*a, b and 2.5*b 
poly5 = sbm._convexsets.Polytope(np.vstack((a,0.5*a,b,2.5*b)))
# Get the vertices of the new polytope
d = poly5.generators()
print d
print d.shape
# Take the convex hull
polynew = poly5.convexhull()
# Check out how the vertices changed
e = polynew.generators()
print e
print e.shape
