#!/usr/bin/env python
from os.path import join

def configuration(parent_package='',top_path=None):
    from numpy.distutils.misc_util import Configuration
    from numpy.distutils.system_info import get_info
    config = Configuration('setbasedmethods', parent_package, top_path)
    ######################################################################
    # Provide GMP library information
    ######################################################################
    gmp_include = '/usr/local/include'
    gmp_lib = '/usr/local/lib'
    ######################################################################
    # Nothing needs to be adjusted below. TODO: Packaging still suboptimal
    ######################################################################
    config.add_subpackage('convexsets')
    sources = [join('external-src/cddlib-094f/lib-src-gmp/','*.c'),
               join('external-src/MINKSUM_1.6.2/wrap-gmp-gcc4/','*.cc'),
               join('external-src/MINKSUM_1.6.2/lib-src/','*.cc'),
               join('Src/','*.cxx'),
               join('Src/','*.c'),
               '_convexsets.cpp']

    includes = ['external-src/MINKSUM_1.6.2/wrap-gmp-gcc4/',
                'external-src/MINKSUM_1.6.2/lib-src/',
                'external-src/cddlib-094f/lib-src-gmp',
                '.']
    includes.append(gmp_include)

    config.add_extension('convexsets._convexsets',
                         sources = sources,
                         include_dirs = includes,
                         library_dirs = [gmp_lib],
                         define_macros = [('GMPRATIONAL',None),('VERBOSE',None)],
                         extra_compile_args = ['-funroll-loops'],
                         libraries = ['gmp'])
    return config

if __name__ == "__main__":
    from numpy.distutils.core import setup
    setup(configuration=configuration, version='0.1.0')
